/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.31 from the
 * contents of perl_zeromq.xs. Do not edit this file, edit perl_zeromq.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "xs/perl_zeromq.xs"
#include "perl_zeromq.h"
#include "xshelper.h"

#if (PERLZMQ_TRACE > 0)
#define PerlZMQ_trace(...) \
    { \
        PerlIO_printf(PerlIO_stderr(), "[perlzmq] "); \
        PerlIO_printf(PerlIO_stderr(), __VA_ARGS__); \
        PerlIO_printf(PerlIO_stderr(), "\n"); \
    }
#else
#define PerlZMQ_trace(...)
#endif

STATIC_INLINE void
PerlZMQ_set_bang(pTHX_ int err) {
    SV *errsv = get_sv("!", GV_ADD);
    PerlZMQ_trace("Set ERRSV ($!) to %d", err);
    sv_setiv(errsv, err);
}

STATIC_INLINE int
PerlZMQ_Raw_Message_mg_dup(pTHX_ MAGIC* const mg, CLONE_PARAMS* const param) {
    PerlZMQ_Raw_Message *const src = (PerlZMQ_Raw_Message *) mg->mg_ptr;
    PerlZMQ_Raw_Message *dest;

    PerlZMQ_trace("Message -> dup");
    PERL_UNUSED_VAR( param );
 
    Newxz( dest, 1, PerlZMQ_Raw_Message );
    zmq_msg_init( dest );
    zmq_msg_copy ( dest, src );
    mg->mg_ptr = (char *) dest;
    return 0;
}

STATIC_INLINE int
PerlZMQ_Raw_Message_mg_free( pTHX_ SV * const sv, MAGIC *const mg ) {
    PerlZMQ_Raw_Message* const msg = (PerlZMQ_Raw_Message *) mg->mg_ptr;

    PERL_UNUSED_VAR(sv);
    PerlZMQ_trace( "START mg_free (Message)" );
    if ( msg != NULL ) {
        PerlZMQ_trace( " + zmq message %p", msg );
        zmq_msg_close( msg );
        Safefree( msg );
    }
    PerlZMQ_trace( "END mg_free (Message)" );
    return 1;
}

STATIC_INLINE MAGIC*
PerlZMQ_Raw_Message_mg_find(pTHX_ SV* const sv, const MGVTBL* const vtbl){
    MAGIC* mg;

    assert(sv   != NULL);
    assert(vtbl != NULL);

    for(mg = SvMAGIC(sv); mg; mg = mg->mg_moremagic){
        if(mg->mg_virtual == vtbl){
            assert(mg->mg_type == PERL_MAGIC_ext);
            return mg;
        }
    }

    croak("ZeroMQ::Raw::Message: Invalid ZeroMQ::Raw::Message object was passed to mg_find");
    return NULL; /* not reached */
}

STATIC_INLINE int
PerlZMQ_Raw_Context_mg_free( pTHX_ SV * const sv, MAGIC *const mg ) {
    PerlZMQ_Raw_Context* const ctxt = (PerlZMQ_Raw_Context *) mg->mg_ptr;
    PERL_UNUSED_VAR(sv);

    PerlZMQ_trace("START mg_free (Context)");
    if (ctxt != NULL) {
#ifdef USE_ITHREADS
        PerlZMQ_trace( " + thread enabled. thread %p", aTHX );
        PerlZMQ_trace( " + context wrapper %p with zmq context %p", ctxt, ctxt->ctxt );
        if ( ctxt->interp == aTHX ) { /* is where I came from */
            PerlZMQ_trace( " + detected mg_free from creating thread %p, cleaning up", aTHX );
            zmq_term( ctxt->ctxt );
            mg->mg_ptr = NULL;
            Safefree(ctxt);
        }
#else
        PerlZMQ_trace(" + zmq context %p", ctxt);
        zmq_term( ctxt );
        mg->mg_ptr = NULL;
#endif
    }
    PerlZMQ_trace("END mg_free (Context)");
    return 1;
}

STATIC_INLINE MAGIC*
PerlZMQ_Raw_Context_mg_find(pTHX_ SV* const sv, const MGVTBL* const vtbl){
    MAGIC* mg;

    assert(sv   != NULL);
    assert(vtbl != NULL);

    for(mg = SvMAGIC(sv); mg; mg = mg->mg_moremagic){
        if(mg->mg_virtual == vtbl){
            assert(mg->mg_type == PERL_MAGIC_ext);
            return mg;
        }
    }

    croak("ZeroMQ::Raw::Context: Invalid ZeroMQ::Raw::Context object was passed to mg_find");
    return NULL; /* not reached */
}

STATIC_INLINE int
PerlZMQ_Raw_Context_mg_dup(pTHX_ MAGIC* const mg, CLONE_PARAMS* const param){
    PERL_UNUSED_VAR(mg);
    PERL_UNUSED_VAR(param);
    return 0;
}

STATIC_INLINE int
PerlZMQ_Raw_Socket_invalidate( PerlZMQ_Raw_Socket *sock )
{
    SV *ctxt_sv = sock->assoc_ctxt;
    int rv;

    PerlZMQ_trace("START socket_invalidate");
    PerlZMQ_trace(" + zmq socket %p", sock->socket);
    rv = zmq_close( sock->socket );

    if ( SvOK(ctxt_sv) ) {
        PerlZMQ_trace(" + associated context: %p", ctxt_sv);
        SvREFCNT_dec(ctxt_sv);
        sock->assoc_ctxt = NULL;
    }

    Safefree(sock);

    PerlZMQ_trace("END socket_invalidate");
    return rv;
}

STATIC_INLINE int
PerlZMQ_Raw_Socket_mg_free(pTHX_ SV* const sv, MAGIC* const mg)
{
    PerlZMQ_Raw_Socket* const sock = (PerlZMQ_Raw_Socket *) mg->mg_ptr;
    PERL_UNUSED_VAR(sv);
    PerlZMQ_trace("START mg_free (Socket)");
    if (sock) {
        PerlZMQ_Raw_Socket_invalidate( sock );
        mg->mg_ptr = NULL;
    }
    PerlZMQ_trace("END mg_free (Socket)");
    return 1;
}

STATIC_INLINE int
PerlZMQ_Raw_Socket_mg_dup(pTHX_ MAGIC* const mg, CLONE_PARAMS* const param){
#ifdef USE_ITHREADS /* single threaded perl has no "xxx_dup()" APIs */
    mg->mg_ptr = NULL;
    PERL_UNUSED_VAR(param);
#else
    PERL_UNUSED_VAR(mg);
    PERL_UNUSED_VAR(param);
#endif
    return 0;
}

STATIC_INLINE MAGIC*
PerlZMQ_Raw_Socket_mg_find(pTHX_ SV* const sv, const MGVTBL* const vtbl){
    MAGIC* mg;

    assert(sv   != NULL);
    assert(vtbl != NULL);

    for(mg = SvMAGIC(sv); mg; mg = mg->mg_moremagic){
        if(mg->mg_virtual == vtbl){
            assert(mg->mg_type == PERL_MAGIC_ext);
            return mg;
        }
    }

    croak("ZeroMQ::Socket: Invalid ZeroMQ::Socket object was passed to mg_find");
    return NULL; /* not reached */
}

STATIC_INLINE void 
PerlZMQ_free_string(void *data, void *hint) {
    PERL_UNUSED_ARG(hint);
    free(data);
}

#include "mg-xs.inc"

#line 205 "xs/perl_zeromq.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 349 "xs/perl_zeromq.c"

XS_EUPXS(XS_ZeroMQ_version); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZeroMQ_version)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 207 "xs/perl_zeromq.xs"
        int major, minor, patch;
        I32 gimme;
#line 363 "xs/perl_zeromq.c"
#line 210 "xs/perl_zeromq.xs"
        gimme = GIMME_V;
        if (gimme == G_VOID) {
            /* WTF? you don't want a return value?! */
            XSRETURN(0);
        }

        zmq_version(&major, &minor, &patch);
        if (gimme == G_SCALAR) {
            XPUSHs( sv_2mortal( newSVpvf( "%d.%d.%d", major, minor, patch ) ) );
            XSRETURN(1);
        } else {
            mXPUSHi( major );
            mXPUSHi( minor );
            mXPUSHi( patch );
            XSRETURN(3);
        }
#line 381 "xs/perl_zeromq.c"
	PUTBACK;
	return;
    }
}


/* INCLUDE:  Including 'const-xs.inc' from 'perl_zeromq.xs' */


XS_EUPXS(XS_ZeroMQ__Constants__constant); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZeroMQ__Constants__constant)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	IV	RETVAL;
	dXSTARG;
#line 65 "xs/const-xs.inc"
        RETVAL = ix;
#line 403 "xs/perl_zeromq.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


/* INCLUDE: Returning to 'perl_zeromq.xs' from 'const-xs.inc' */


XS_EUPXS(XS_ZeroMQ__Raw_zmq_init); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZeroMQ__Raw_zmq_init)
{
    dVAR; dXSARGS;
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "nthreads = 5");
    {
	int	nthreads;
#line 239 "xs/perl_zeromq.xs"
        SV *class_sv = sv_2mortal(newSVpvn( "ZeroMQ::Raw::Context", 20 ));
#line 423 "xs/perl_zeromq.c"
	PerlZMQ_Raw_Context *	RETVAL;

	if (items < 1)
	    nthreads = 5;
	else {
	    nthreads = (int)SvIV(ST(0))
;
	}
#line 241 "xs/perl_zeromq.xs"
        PerlZMQ_trace( "START zmq_init" );
#ifdef USE_ITHREADS
        PerlZMQ_trace( " + threads enabled, aTHX %p", aTHX );
        Newxz( RETVAL, 1, PerlZMQ_Raw_Context );
        RETVAL->interp = aTHX;
        RETVAL->ctxt   = zmq_init( nthreads );
        PerlZMQ_trace( " + created context wrapper %p", RETVAL );
        PerlZMQ_trace( " + zmq context %p", RETVAL->ctxt );
#else
        PerlZMQ_trace( " + non-threaded context");
        RETVAL = zmq_init( nthreads );
#endif
        PerlZMQ_trace( "END zmq_init");
#line 446 "xs/perl_zeromq.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    if (!RETVAL)	  /* if null */
		SvOK_off(RETVALSV); /* then return as undef instead of reaf to undef */
	    else {
		/* setup RETVALSV as a ref to a blessed hash hv */
		MAGIC *mg;
		HV *hv = newHV();
		const char *classname = "ZeroMQ::Raw::Context";
		/* take (sub)class name to use from class_sv if appropriate */
		if (SvMAGICAL(class_sv))
		    mg_get(class_sv);
		if (SvOK( class_sv ) && sv_derived_from(class_sv, classname ) ) {
		    if(SvROK(class_sv) && SvOBJECT(SvRV(class_sv))) {
			classname = sv_reftype(SvRV(class_sv), TRUE);
		    } else {
			classname = SvPV_nolen(class_sv);
		    }
		}
		sv_setsv(RETVALSV, sv_2mortal(newRV_noinc((SV*)hv)));
		(void)sv_bless(RETVALSV, gv_stashpv(classname, TRUE));
		mg = sv_magicext((SV*)hv, NULL, PERL_MAGIC_ext, &PerlZMQ_Raw_Context_vtbl, (char*) RETVAL, 0);
		mg->mg_flags |= MGf_DUP;
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZeroMQ__Raw_zmq_term); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZeroMQ__Raw_zmq_term)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "context");
    {
	PerlZMQ_Raw_Context *	context;
	int	RETVAL;
	dXSTARG;

    {
        MAGIC *mg;
        context = NULL;
        if (! sv_isobject(ST(0))) {
            croak("Argument is not an object");
        }
        /* if it got here, it's a blessed reference. better be an HV */
        {
            SV *svr;
            SV **closed;
            svr = SvRV(ST(0));
            if (! svr ) {
                croak("PANIC: Could not get reference from blessed object.");
            }
            if (SvTYPE(svr) != SVt_PVHV) {
                croak("PANIC: Underlying storage of blessed reference is not a hash.");
            }
            closed = hv_fetchs( (HV *) svr, "_closed", 0 );
            if (closed != NULL && SvTRUE(*closed)) {
                /* if it's already closed, just return */
                XSRETURN_EMPTY;
            }
        }
        mg = PerlZMQ_Raw_Context_mg_find(aTHX_ SvRV(ST(0)), &PerlZMQ_Raw_Context_vtbl);
        if (mg) {
            context = (PerlZMQ_Raw_Context *) mg->mg_ptr;
        }
        if (context == NULL)
            croak("Invalid ZeroMQ::Raw::Context object (perhaps you've already freed it?)");
    }
;
#line 261 "xs/perl_zeromq.xs"
#ifdef USE_ITHREADS
        RETVAL = zmq_term( context->ctxt );
#else
        RETVAL = zmq_term( context );
#endif
        if (RETVAL == 0) {
            /* Cancel the SV's mg attr so to not call zmq_term automatically */
            MAGIC *mg =
                PerlZMQ_Raw_Context_mg_find( aTHX_ SvRV(ST(0)), &PerlZMQ_Raw_Context_vtbl );
            mg->mg_ptr = NULL;
        }

        /* mark the original SV's _closed flag as true */
        {
            SV *svr = SvRV(ST(0));
            if (hv_stores( (HV *) svr, "_closed", &PL_sv_yes ) == NULL) {
                croak("PANIC: Failed to store closed flag on blessed reference");
            }
        }
#line 541 "xs/perl_zeromq.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZeroMQ__Raw_zmq_msg_init); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZeroMQ__Raw_zmq_msg_init)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 286 "xs/perl_zeromq.xs"
        SV *class_sv = sv_2mortal(newSVpvn( "ZeroMQ::Raw::Message", 20 ));
        int rc;
#line 558 "xs/perl_zeromq.c"
	PerlZMQ_Raw_Message *	RETVAL;
#line 289 "xs/perl_zeromq.xs"
        Newxz( RETVAL, 1, PerlZMQ_Raw_Message );
        rc = zmq_msg_init( RETVAL );
        if ( rc != 0 ) {
            SET_BANG;
            zmq_msg_close( RETVAL );
            RETVAL = NULL;
        }
#line 568 "xs/perl_zeromq.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    if (!RETVAL)	  /* if null */
		SvOK_off(RETVALSV); /* then return as undef instead of reaf to undef */
	    else {
		/* setup RETVALSV as a ref to a blessed hash hv */
		MAGIC *mg;
		HV *hv = newHV();
		const char *classname = "ZeroMQ::Raw::Message";
		/* take (sub)class name to use from class_sv if appropriate */
		if (SvMAGICAL(class_sv))
		    mg_get(class_sv);
		if (SvOK( class_sv ) && sv_derived_from(class_sv, classname ) ) {
		    if(SvROK(class_sv) && SvOBJECT(SvRV(class_sv))) {
			classname = sv_reftype(SvRV(class_sv), TRUE);
		    } else {
			classname = SvPV_nolen(class_sv);
		    }
		}
		sv_setsv(RETVALSV, sv_2mortal(newRV_noinc((SV*)hv)));
		(void)sv_bless(RETVALSV, gv_stashpv(classname, TRUE));
		mg = sv_magicext((SV*)hv, NULL, PERL_MAGIC_ext, &PerlZMQ_Raw_Message_vtbl, (char*) RETVAL, 0);
		mg->mg_flags |= MGf_DUP;
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZeroMQ__Raw_zmq_msg_init_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZeroMQ__Raw_zmq_msg_init_size)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "size");
    {
	IV	size = (IV)SvIV(ST(0))
;
#line 303 "xs/perl_zeromq.xs"
        SV *class_sv = sv_2mortal(newSVpvn( "ZeroMQ::Raw::Message", 20 ));
        int rc;
#line 613 "xs/perl_zeromq.c"
	PerlZMQ_Raw_Message *	RETVAL;
#line 306 "xs/perl_zeromq.xs"
        Newxz( RETVAL, 1, PerlZMQ_Raw_Message );
        rc = zmq_msg_init_size(RETVAL, size);
        if ( rc != 0 ) {
            SET_BANG;
            zmq_msg_close( RETVAL );
            RETVAL = NULL;
        }
#line 623 "xs/perl_zeromq.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    if (!RETVAL)	  /* if null */
		SvOK_off(RETVALSV); /* then return as undef instead of reaf to undef */
	    else {
		/* setup RETVALSV as a ref to a blessed hash hv */
		MAGIC *mg;
		HV *hv = newHV();
		const char *classname = "ZeroMQ::Raw::Message";
		/* take (sub)class name to use from class_sv if appropriate */
		if (SvMAGICAL(class_sv))
		    mg_get(class_sv);
		if (SvOK( class_sv ) && sv_derived_from(class_sv, classname ) ) {
		    if(SvROK(class_sv) && SvOBJECT(SvRV(class_sv))) {
			classname = sv_reftype(SvRV(class_sv), TRUE);
		    } else {
			classname = SvPV_nolen(class_sv);
		    }
		}
		sv_setsv(RETVALSV, sv_2mortal(newRV_noinc((SV*)hv)));
		(void)sv_bless(RETVALSV, gv_stashpv(classname, TRUE));
		mg = sv_magicext((SV*)hv, NULL, PERL_MAGIC_ext, &PerlZMQ_Raw_Message_vtbl, (char*) RETVAL, 0);
		mg->mg_flags |= MGf_DUP;
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZeroMQ__Raw_zmq_msg_init_data); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZeroMQ__Raw_zmq_msg_init_data)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "data, size = -1");
    {
	SV *	data = ST(0)
;
	IV	size;
#line 321 "xs/perl_zeromq.xs"
        SV *class_sv = sv_2mortal(newSVpvn( "ZeroMQ::Raw::Message", 20 ));
        STRLEN x_data_len;
        char *sv_data = SvPV(data, x_data_len);
        char *x_data;
        int rc;
#line 672 "xs/perl_zeromq.c"
	PerlZMQ_Raw_Message *	RETVAL;

	if (items < 2)
	    size = -1;
	else {
	    size = (IV)SvIV(ST(1))
;
	}
#line 327 "xs/perl_zeromq.xs"
        if (size >= 0) {
            x_data_len = size;
        }
        Newxz( RETVAL, 1, PerlZMQ_Raw_Message );
        x_data = (char *)malloc(x_data_len);
        memcpy(x_data, sv_data, x_data_len);
        rc = zmq_msg_init_data(RETVAL, x_data, x_data_len, PerlZMQ_free_string, NULL);
        if ( rc != 0 ) {
            SET_BANG;
            zmq_msg_close( RETVAL );
            RETVAL = NULL;
        }
        else {
            PerlZMQ_trace("zmq_msg_init_data created message %p", RETVAL);
        }
#line 697 "xs/perl_zeromq.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    if (!RETVAL)	  /* if null */
		SvOK_off(RETVALSV); /* then return as undef instead of reaf to undef */
	    else {
		/* setup RETVALSV as a ref to a blessed hash hv */
		MAGIC *mg;
		HV *hv = newHV();
		const char *classname = "ZeroMQ::Raw::Message";
		/* take (sub)class name to use from class_sv if appropriate */
		if (SvMAGICAL(class_sv))
		    mg_get(class_sv);
		if (SvOK( class_sv ) && sv_derived_from(class_sv, classname ) ) {
		    if(SvROK(class_sv) && SvOBJECT(SvRV(class_sv))) {
			classname = sv_reftype(SvRV(class_sv), TRUE);
		    } else {
			classname = SvPV_nolen(class_sv);
		    }
		}
		sv_setsv(RETVALSV, sv_2mortal(newRV_noinc((SV*)hv)));
		(void)sv_bless(RETVALSV, gv_stashpv(classname, TRUE));
		mg = sv_magicext((SV*)hv, NULL, PERL_MAGIC_ext, &PerlZMQ_Raw_Message_vtbl, (char*) RETVAL, 0);
		mg->mg_flags |= MGf_DUP;
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZeroMQ__Raw_zmq_msg_data); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZeroMQ__Raw_zmq_msg_data)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "message");
    {
	PerlZMQ_Raw_Message *	message;
	SV *	RETVAL;

    {
        MAGIC *mg;
        message = NULL;
        if (! sv_isobject(ST(0))) {
            croak("Argument is not an object");
        }
        /* if it got here, it's a blessed reference. better be an HV */
        {
            SV *svr;
            SV **closed;
            svr = SvRV(ST(0));
            if (! svr ) {
                croak("PANIC: Could not get reference from blessed object.");
            }
            if (SvTYPE(svr) != SVt_PVHV) {
                croak("PANIC: Underlying storage of blessed reference is not a hash.");
            }
            closed = hv_fetchs( (HV *) svr, "_closed", 0 );
            if (closed != NULL && SvTRUE(*closed)) {
                /* if it's already closed, just return */
                XSRETURN_EMPTY;
            }
        }
        mg = PerlZMQ_Raw_Message_mg_find(aTHX_ SvRV(ST(0)), &PerlZMQ_Raw_Message_vtbl);
        if (mg) {
            message = (PerlZMQ_Raw_Message *) mg->mg_ptr;
        }
        if (message == NULL)
            croak("Invalid ZeroMQ::Raw::Message object (perhaps you've already freed it?)");
    }
;
#line 349 "xs/perl_zeromq.xs"
        RETVAL = newSV(0);
        sv_setpvn( RETVAL, (char *) zmq_msg_data(message), (STRLEN) zmq_msg_size(message) );
#line 774 "xs/perl_zeromq.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZeroMQ__Raw_zmq_msg_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZeroMQ__Raw_zmq_msg_size)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "message");
    {
	PerlZMQ_Raw_Message *	message;
	size_t	RETVAL;
	dXSTARG;

    {
        MAGIC *mg;
        message = NULL;
        if (! sv_isobject(ST(0))) {
            croak("Argument is not an object");
        }
        /* if it got here, it's a blessed reference. better be an HV */
        {
            SV *svr;
            SV **closed;
            svr = SvRV(ST(0));
            if (! svr ) {
                croak("PANIC: Could not get reference from blessed object.");
            }
            if (SvTYPE(svr) != SVt_PVHV) {
                croak("PANIC: Underlying storage of blessed reference is not a hash.");
            }
            closed = hv_fetchs( (HV *) svr, "_closed", 0 );
            if (closed != NULL && SvTRUE(*closed)) {
                /* if it's already closed, just return */
                XSRETURN_EMPTY;
            }
        }
        mg = PerlZMQ_Raw_Message_mg_find(aTHX_ SvRV(ST(0)), &PerlZMQ_Raw_Message_vtbl);
        if (mg) {
            message = (PerlZMQ_Raw_Message *) mg->mg_ptr;
        }
        if (message == NULL)
            croak("Invalid ZeroMQ::Raw::Message object (perhaps you've already freed it?)");
    }
;
#line 358 "xs/perl_zeromq.xs"
        RETVAL = zmq_msg_size(message);
#line 826 "xs/perl_zeromq.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZeroMQ__Raw_zmq_msg_close); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZeroMQ__Raw_zmq_msg_close)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "message");
    {
	PerlZMQ_Raw_Message *	message;
	int	RETVAL;
	dXSTARG;

    {
        MAGIC *mg;
        message = NULL;
        if (! sv_isobject(ST(0))) {
            croak("Argument is not an object");
        }
        /* if it got here, it's a blessed reference. better be an HV */
        {
            SV *svr;
            SV **closed;
            svr = SvRV(ST(0));
            if (! svr ) {
                croak("PANIC: Could not get reference from blessed object.");
            }
            if (SvTYPE(svr) != SVt_PVHV) {
                croak("PANIC: Underlying storage of blessed reference is not a hash.");
            }
            closed = hv_fetchs( (HV *) svr, "_closed", 0 );
            if (closed != NULL && SvTRUE(*closed)) {
                /* if it's already closed, just return */
                XSRETURN_EMPTY;
            }
        }
        mg = PerlZMQ_Raw_Message_mg_find(aTHX_ SvRV(ST(0)), &PerlZMQ_Raw_Message_vtbl);
        if (mg) {
            message = (PerlZMQ_Raw_Message *) mg->mg_ptr;
        }
        if (message == NULL)
            croak("Invalid ZeroMQ::Raw::Message object (perhaps you've already freed it?)");
    }
;
#line 366 "xs/perl_zeromq.xs"
        PerlZMQ_trace("START zmq_msg_close");
        RETVAL = zmq_msg_close(message);
        Safefree(message);
        {
            MAGIC *mg =
                 PerlZMQ_Raw_Message_mg_find( aTHX_ SvRV(ST(0)), &PerlZMQ_Raw_Message_vtbl );
             mg->mg_ptr = NULL;
        }
        /* mark the original SV's _closed flag as true */
        {
            SV *svr = SvRV(ST(0));
            if (hv_stores( (HV *) svr, "_closed", &PL_sv_yes ) == NULL) {
                croak("PANIC: Failed to store closed flag on blessed reference");
            }
        }
        PerlZMQ_trace("END zmq_msg_close");
#line 892 "xs/perl_zeromq.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZeroMQ__Raw_zmq_msg_move); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZeroMQ__Raw_zmq_msg_move)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "dest, src");
    {
	PerlZMQ_Raw_Message *	dest;
	PerlZMQ_Raw_Message *	src;
	int	RETVAL;
	dXSTARG;

    {
        MAGIC *mg;
        dest = NULL;
        if (! sv_isobject(ST(0))) {
            croak("Argument is not an object");
        }
        /* if it got here, it's a blessed reference. better be an HV */
        {
            SV *svr;
            SV **closed;
            svr = SvRV(ST(0));
            if (! svr ) {
                croak("PANIC: Could not get reference from blessed object.");
            }
            if (SvTYPE(svr) != SVt_PVHV) {
                croak("PANIC: Underlying storage of blessed reference is not a hash.");
            }
            closed = hv_fetchs( (HV *) svr, "_closed", 0 );
            if (closed != NULL && SvTRUE(*closed)) {
                /* if it's already closed, just return */
                XSRETURN_EMPTY;
            }
        }
        mg = PerlZMQ_Raw_Message_mg_find(aTHX_ SvRV(ST(0)), &PerlZMQ_Raw_Message_vtbl);
        if (mg) {
            dest = (PerlZMQ_Raw_Message *) mg->mg_ptr;
        }
        if (dest == NULL)
            croak("Invalid ZeroMQ::Raw::Message object (perhaps you've already freed it?)");
    }
;

    {
        MAGIC *mg;
        src = NULL;
        if (! sv_isobject(ST(1))) {
            croak("Argument is not an object");
        }
        /* if it got here, it's a blessed reference. better be an HV */
        {
            SV *svr;
            SV **closed;
            svr = SvRV(ST(1));
            if (! svr ) {
                croak("PANIC: Could not get reference from blessed object.");
            }
            if (SvTYPE(svr) != SVt_PVHV) {
                croak("PANIC: Underlying storage of blessed reference is not a hash.");
            }
            closed = hv_fetchs( (HV *) svr, "_closed", 0 );
            if (closed != NULL && SvTRUE(*closed)) {
                /* if it's already closed, just return */
                XSRETURN_EMPTY;
            }
        }
        mg = PerlZMQ_Raw_Message_mg_find(aTHX_ SvRV(ST(1)), &PerlZMQ_Raw_Message_vtbl);
        if (mg) {
            src = (PerlZMQ_Raw_Message *) mg->mg_ptr;
        }
        if (src == NULL)
            croak("Invalid ZeroMQ::Raw::Message object (perhaps you've already freed it?)");
    }
;
#line 390 "xs/perl_zeromq.xs"
        RETVAL = zmq_msg_move( dest, src );
#line 976 "xs/perl_zeromq.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZeroMQ__Raw_zmq_msg_copy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZeroMQ__Raw_zmq_msg_copy)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "dest, src");
    {
	PerlZMQ_Raw_Message *	dest;
	PerlZMQ_Raw_Message *	src;
	int	RETVAL;
	dXSTARG;

    {
        MAGIC *mg;
        dest = NULL;
        if (! sv_isobject(ST(0))) {
            croak("Argument is not an object");
        }
        /* if it got here, it's a blessed reference. better be an HV */
        {
            SV *svr;
            SV **closed;
            svr = SvRV(ST(0));
            if (! svr ) {
                croak("PANIC: Could not get reference from blessed object.");
            }
            if (SvTYPE(svr) != SVt_PVHV) {
                croak("PANIC: Underlying storage of blessed reference is not a hash.");
            }
            closed = hv_fetchs( (HV *) svr, "_closed", 0 );
            if (closed != NULL && SvTRUE(*closed)) {
                /* if it's already closed, just return */
                XSRETURN_EMPTY;
            }
        }
        mg = PerlZMQ_Raw_Message_mg_find(aTHX_ SvRV(ST(0)), &PerlZMQ_Raw_Message_vtbl);
        if (mg) {
            dest = (PerlZMQ_Raw_Message *) mg->mg_ptr;
        }
        if (dest == NULL)
            croak("Invalid ZeroMQ::Raw::Message object (perhaps you've already freed it?)");
    }
;

    {
        MAGIC *mg;
        src = NULL;
        if (! sv_isobject(ST(1))) {
            croak("Argument is not an object");
        }
        /* if it got here, it's a blessed reference. better be an HV */
        {
            SV *svr;
            SV **closed;
            svr = SvRV(ST(1));
            if (! svr ) {
                croak("PANIC: Could not get reference from blessed object.");
            }
            if (SvTYPE(svr) != SVt_PVHV) {
                croak("PANIC: Underlying storage of blessed reference is not a hash.");
            }
            closed = hv_fetchs( (HV *) svr, "_closed", 0 );
            if (closed != NULL && SvTRUE(*closed)) {
                /* if it's already closed, just return */
                XSRETURN_EMPTY;
            }
        }
        mg = PerlZMQ_Raw_Message_mg_find(aTHX_ SvRV(ST(1)), &PerlZMQ_Raw_Message_vtbl);
        if (mg) {
            src = (PerlZMQ_Raw_Message *) mg->mg_ptr;
        }
        if (src == NULL)
            croak("Invalid ZeroMQ::Raw::Message object (perhaps you've already freed it?)");
    }
;
#line 399 "xs/perl_zeromq.xs"
        RETVAL = zmq_msg_copy( dest, src );
#line 1060 "xs/perl_zeromq.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZeroMQ__Raw_zmq_socket); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZeroMQ__Raw_zmq_socket)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ctxt, type");
    {
	PerlZMQ_Raw_Context *	ctxt;
	IV	type = (IV)SvIV(ST(1))
;
#line 408 "xs/perl_zeromq.xs"
        SV *class_sv = sv_2mortal(newSVpvn( "ZeroMQ::Raw::Socket", 19 ));
#line 1079 "xs/perl_zeromq.c"
	PerlZMQ_Raw_Socket *	RETVAL;

    {
        MAGIC *mg;
        ctxt = NULL;
        if (! sv_isobject(ST(0))) {
            croak("Argument is not an object");
        }
        /* if it got here, it's a blessed reference. better be an HV */
        {
            SV *svr;
            SV **closed;
            svr = SvRV(ST(0));
            if (! svr ) {
                croak("PANIC: Could not get reference from blessed object.");
            }
            if (SvTYPE(svr) != SVt_PVHV) {
                croak("PANIC: Underlying storage of blessed reference is not a hash.");
            }
            closed = hv_fetchs( (HV *) svr, "_closed", 0 );
            if (closed != NULL && SvTRUE(*closed)) {
                /* if it's already closed, just return */
                XSRETURN_EMPTY;
            }
        }
        mg = PerlZMQ_Raw_Context_mg_find(aTHX_ SvRV(ST(0)), &PerlZMQ_Raw_Context_vtbl);
        if (mg) {
            ctxt = (PerlZMQ_Raw_Context *) mg->mg_ptr;
        }
        if (ctxt == NULL)
            croak("Invalid ZeroMQ::Raw::Context object (perhaps you've already freed it?)");
    }
;
#line 410 "xs/perl_zeromq.xs"
        PerlZMQ_trace( "START zmq_socket" );
        Newxz( RETVAL, 1, PerlZMQ_Raw_Socket );
        RETVAL->assoc_ctxt = NULL;
        RETVAL->socket = NULL;
#ifdef USE_ITHREADS
        PerlZMQ_trace( " + context wrapper %p, zmq context %p", ctxt, ctxt->ctxt );
        RETVAL->socket = zmq_socket( ctxt->ctxt, type );
#else
        PerlZMQ_trace( " + zmq context %p", ctxt );
        RETVAL->socket = zmq_socket( ctxt, type );
#endif
        RETVAL->assoc_ctxt = ST(0);
        SvREFCNT_inc(RETVAL->assoc_ctxt);
        PerlZMQ_trace( " + created socket %p", RETVAL );
        PerlZMQ_trace( "END zmq_socket" );
#line 1129 "xs/perl_zeromq.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    if (!RETVAL)	  /* if null */
		SvOK_off(RETVALSV); /* then return as undef instead of reaf to undef */
	    else {
		/* setup RETVALSV as a ref to a blessed hash hv */
		MAGIC *mg;
		HV *hv = newHV();
		const char *classname = "ZeroMQ::Raw::Socket";
		/* take (sub)class name to use from class_sv if appropriate */
		if (SvMAGICAL(class_sv))
		    mg_get(class_sv);
		if (SvOK( class_sv ) && sv_derived_from(class_sv, classname ) ) {
		    if(SvROK(class_sv) && SvOBJECT(SvRV(class_sv))) {
			classname = sv_reftype(SvRV(class_sv), TRUE);
		    } else {
			classname = SvPV_nolen(class_sv);
		    }
		}
		sv_setsv(RETVALSV, sv_2mortal(newRV_noinc((SV*)hv)));
		(void)sv_bless(RETVALSV, gv_stashpv(classname, TRUE));
		mg = sv_magicext((SV*)hv, NULL, PERL_MAGIC_ext, &PerlZMQ_Raw_Socket_vtbl, (char*) RETVAL, 0);
		mg->mg_flags |= MGf_DUP;
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZeroMQ__Raw_zmq_close); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZeroMQ__Raw_zmq_close)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "socket");
    {
	PerlZMQ_Raw_Socket *	socket;
	int	RETVAL;
	dXSTARG;

    {
        MAGIC *mg;
        socket = NULL;
        if (! sv_isobject(ST(0))) {
            croak("Argument is not an object");
        }
        /* if it got here, it's a blessed reference. better be an HV */
        {
            SV *svr;
            SV **closed;
            svr = SvRV(ST(0));
            if (! svr ) {
                croak("PANIC: Could not get reference from blessed object.");
            }
            if (SvTYPE(svr) != SVt_PVHV) {
                croak("PANIC: Underlying storage of blessed reference is not a hash.");
            }
            closed = hv_fetchs( (HV *) svr, "_closed", 0 );
            if (closed != NULL && SvTRUE(*closed)) {
                /* if it's already closed, just return */
                XSRETURN_EMPTY;
            }
        }
        mg = PerlZMQ_Raw_Socket_mg_find(aTHX_ SvRV(ST(0)), &PerlZMQ_Raw_Socket_vtbl);
        if (mg) {
            socket = (PerlZMQ_Raw_Socket *) mg->mg_ptr;
        }
        if (socket == NULL)
            croak("Invalid ZeroMQ::Raw::Socket object (perhaps you've already freed it?)");
    }
;
#line 432 "xs/perl_zeromq.xs"
        RETVAL = PerlZMQ_Raw_Socket_invalidate( socket );
        /* Cancel the SV's mg attr so to not call socket_invalidate again
           during Socket_mg_free
        */
        {
            MAGIC *mg =
                 PerlZMQ_Raw_Socket_mg_find( aTHX_ SvRV(ST(0)), &PerlZMQ_Raw_Socket_vtbl );
             mg->mg_ptr = NULL;
        }

        /* mark the original SV's _closed flag as true */
        {
            SV *svr = SvRV(ST(0));
            if (hv_stores( (HV *) svr, "_closed", &PL_sv_yes ) == NULL) {
                croak("PANIC: Failed to store closed flag on blessed reference");
            }
        }
#line 1222 "xs/perl_zeromq.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZeroMQ__Raw_zmq_connect); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZeroMQ__Raw_zmq_connect)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "socket, addr");
    {
	PerlZMQ_Raw_Socket *	socket;
	char *	addr = (char *)SvPV_nolen(ST(1))
;
	int	RETVAL;
	dXSTARG;

    {
        MAGIC *mg;
        socket = NULL;
        if (! sv_isobject(ST(0))) {
            croak("Argument is not an object");
        }
        /* if it got here, it's a blessed reference. better be an HV */
        {
            SV *svr;
            SV **closed;
            svr = SvRV(ST(0));
            if (! svr ) {
                croak("PANIC: Could not get reference from blessed object.");
            }
            if (SvTYPE(svr) != SVt_PVHV) {
                croak("PANIC: Underlying storage of blessed reference is not a hash.");
            }
            closed = hv_fetchs( (HV *) svr, "_closed", 0 );
            if (closed != NULL && SvTRUE(*closed)) {
                /* if it's already closed, just return */
                XSRETURN_EMPTY;
            }
        }
        mg = PerlZMQ_Raw_Socket_mg_find(aTHX_ SvRV(ST(0)), &PerlZMQ_Raw_Socket_vtbl);
        if (mg) {
            socket = (PerlZMQ_Raw_Socket *) mg->mg_ptr;
        }
        if (socket == NULL)
            croak("Invalid ZeroMQ::Raw::Socket object (perhaps you've already freed it?)");
    }
;
#line 457 "xs/perl_zeromq.xs"
        PerlZMQ_trace( "START zmq_connect" );
        PerlZMQ_trace( " + socket %p", socket );
        RETVAL = zmq_connect( socket->socket, addr );
        if (RETVAL != 0) {
            croak( "%s", zmq_strerror( zmq_errno() ) );
        }
        PerlZMQ_trace( "END zmq_connect" );
#line 1281 "xs/perl_zeromq.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZeroMQ__Raw_zmq_bind); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZeroMQ__Raw_zmq_bind)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "socket, addr");
    {
	PerlZMQ_Raw_Socket *	socket;
	char *	addr = (char *)SvPV_nolen(ST(1))
;
	int	RETVAL;
	dXSTARG;

    {
        MAGIC *mg;
        socket = NULL;
        if (! sv_isobject(ST(0))) {
            croak("Argument is not an object");
        }
        /* if it got here, it's a blessed reference. better be an HV */
        {
            SV *svr;
            SV **closed;
            svr = SvRV(ST(0));
            if (! svr ) {
                croak("PANIC: Could not get reference from blessed object.");
            }
            if (SvTYPE(svr) != SVt_PVHV) {
                croak("PANIC: Underlying storage of blessed reference is not a hash.");
            }
            closed = hv_fetchs( (HV *) svr, "_closed", 0 );
            if (closed != NULL && SvTRUE(*closed)) {
                /* if it's already closed, just return */
                XSRETURN_EMPTY;
            }
        }
        mg = PerlZMQ_Raw_Socket_mg_find(aTHX_ SvRV(ST(0)), &PerlZMQ_Raw_Socket_vtbl);
        if (mg) {
            socket = (PerlZMQ_Raw_Socket *) mg->mg_ptr;
        }
        if (socket == NULL)
            croak("Invalid ZeroMQ::Raw::Socket object (perhaps you've already freed it?)");
    }
;
#line 472 "xs/perl_zeromq.xs"
        PerlZMQ_trace( "zmq_bind: socket %p", socket );
        RETVAL = zmq_bind( socket->socket, addr );
        if (RETVAL != 0) {
            croak( "%s", zmq_strerror( zmq_errno() ) );
        }
#line 1338 "xs/perl_zeromq.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZeroMQ__Raw_zmq_recv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZeroMQ__Raw_zmq_recv)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "socket, flags = 0");
    {
	PerlZMQ_Raw_Socket *	socket;
	int	flags;
#line 485 "xs/perl_zeromq.xs"
        SV *class_sv = sv_2mortal(newSVpvn( "ZeroMQ::Raw::Message", 20 ));
        int rv;
        zmq_msg_t msg;
#line 1358 "xs/perl_zeromq.c"
	PerlZMQ_Raw_Message *	RETVAL;

    {
        MAGIC *mg;
        socket = NULL;
        if (! sv_isobject(ST(0))) {
            croak("Argument is not an object");
        }
        /* if it got here, it's a blessed reference. better be an HV */
        {
            SV *svr;
            SV **closed;
            svr = SvRV(ST(0));
            if (! svr ) {
                croak("PANIC: Could not get reference from blessed object.");
            }
            if (SvTYPE(svr) != SVt_PVHV) {
                croak("PANIC: Underlying storage of blessed reference is not a hash.");
            }
            closed = hv_fetchs( (HV *) svr, "_closed", 0 );
            if (closed != NULL && SvTRUE(*closed)) {
                /* if it's already closed, just return */
                XSRETURN_EMPTY;
            }
        }
        mg = PerlZMQ_Raw_Socket_mg_find(aTHX_ SvRV(ST(0)), &PerlZMQ_Raw_Socket_vtbl);
        if (mg) {
            socket = (PerlZMQ_Raw_Socket *) mg->mg_ptr;
        }
        if (socket == NULL)
            croak("Invalid ZeroMQ::Raw::Socket object (perhaps you've already freed it?)");
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(1))
;
	}
#line 489 "xs/perl_zeromq.xs"
        PerlZMQ_trace( "START zmq_recv" );
        RETVAL = NULL;
        zmq_msg_init(&msg);
        rv = zmq_recv(socket->socket, &msg, flags);
        PerlZMQ_trace(" + zmq recv with flags %d", flags);
        PerlZMQ_trace(" + zmq_recv returned with rv '%d'", rv);
        if (rv != 0) {
            SET_BANG;
            zmq_msg_close(&msg);
            PerlZMQ_trace(" + zmq_recv got bad status, closing temporary message");
        } else {
            Newxz(RETVAL, 1, PerlZMQ_Raw_Message);
            zmq_msg_init(RETVAL);
            zmq_msg_copy( RETVAL, &msg );
            zmq_msg_close(&msg);
            PerlZMQ_trace(" + zmq_recv created message %p", RETVAL );
        }
#line 1417 "xs/perl_zeromq.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    if (!RETVAL)	  /* if null */
		SvOK_off(RETVALSV); /* then return as undef instead of reaf to undef */
	    else {
		/* setup RETVALSV as a ref to a blessed hash hv */
		MAGIC *mg;
		HV *hv = newHV();
		const char *classname = "ZeroMQ::Raw::Message";
		/* take (sub)class name to use from class_sv if appropriate */
		if (SvMAGICAL(class_sv))
		    mg_get(class_sv);
		if (SvOK( class_sv ) && sv_derived_from(class_sv, classname ) ) {
		    if(SvROK(class_sv) && SvOBJECT(SvRV(class_sv))) {
			classname = sv_reftype(SvRV(class_sv), TRUE);
		    } else {
			classname = SvPV_nolen(class_sv);
		    }
		}
		sv_setsv(RETVALSV, sv_2mortal(newRV_noinc((SV*)hv)));
		(void)sv_bless(RETVALSV, gv_stashpv(classname, TRUE));
		mg = sv_magicext((SV*)hv, NULL, PERL_MAGIC_ext, &PerlZMQ_Raw_Message_vtbl, (char*) RETVAL, 0);
		mg->mg_flags |= MGf_DUP;
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZeroMQ__Raw_zmq_send); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZeroMQ__Raw_zmq_send)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "socket, message, flags = 0");
    {
	PerlZMQ_Raw_Socket *	socket;
	SV *	message = ST(1)
;
	int	flags;
#line 515 "xs/perl_zeromq.xs"
        PerlZMQ_Raw_Message *msg = NULL;
#line 1463 "xs/perl_zeromq.c"
	int	RETVAL;
	dXSTARG;

    {
        MAGIC *mg;
        socket = NULL;
        if (! sv_isobject(ST(0))) {
            croak("Argument is not an object");
        }
        /* if it got here, it's a blessed reference. better be an HV */
        {
            SV *svr;
            SV **closed;
            svr = SvRV(ST(0));
            if (! svr ) {
                croak("PANIC: Could not get reference from blessed object.");
            }
            if (SvTYPE(svr) != SVt_PVHV) {
                croak("PANIC: Underlying storage of blessed reference is not a hash.");
            }
            closed = hv_fetchs( (HV *) svr, "_closed", 0 );
            if (closed != NULL && SvTRUE(*closed)) {
                /* if it's already closed, just return */
                XSRETURN_EMPTY;
            }
        }
        mg = PerlZMQ_Raw_Socket_mg_find(aTHX_ SvRV(ST(0)), &PerlZMQ_Raw_Socket_vtbl);
        if (mg) {
            socket = (PerlZMQ_Raw_Socket *) mg->mg_ptr;
        }
        if (socket == NULL)
            croak("Invalid ZeroMQ::Raw::Socket object (perhaps you've already freed it?)");
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(2))
;
	}
#line 517 "xs/perl_zeromq.xs"
        if (! SvOK(message))
            croak("ZeroMQ::Socket::send() NULL message passed");

        if (sv_isobject(message) && sv_isa(message, "ZeroMQ::Raw::Message")) {
            MAGIC *mg = PerlZMQ_Raw_Context_mg_find(aTHX_ SvRV(message), &PerlZMQ_Raw_Message_vtbl);
            if (mg) {
                msg = (PerlZMQ_Raw_Message *) mg->mg_ptr;
            }

            if (msg == NULL) {
                croak("Got invalid message object");
            }

            RETVAL = zmq_send(socket->socket, msg, flags);
        } else {
            STRLEN data_len;
            char *x_data;
            char *data = SvPV(message, data_len);
            zmq_msg_t msg;

            x_data = (char *)malloc(data_len);
            memcpy(x_data, data, data_len);
            zmq_msg_init_data(&msg, x_data, data_len, PerlZMQ_free_string, NULL);
            RETVAL = zmq_send(socket->socket, &msg, flags);
            zmq_msg_close( &msg ); 
        }
#line 1532 "xs/perl_zeromq.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZeroMQ__Raw_zmq_getsockopt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZeroMQ__Raw_zmq_getsockopt)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sock, option");
    {
	PerlZMQ_Raw_Socket *	sock;
	int	option = (int)SvIV(ST(1))
;
#line 551 "xs/perl_zeromq.xs"
        char     buf[256];
        int      i;
        uint64_t u64;
        int64_t  i64;
        uint32_t i32;
        size_t   len;
        int      status = -1;
#line 1557 "xs/perl_zeromq.c"
	SV *	RETVAL;

    {
        MAGIC *mg;
        sock = NULL;
        if (! sv_isobject(ST(0))) {
            croak("Argument is not an object");
        }
        /* if it got here, it's a blessed reference. better be an HV */
        {
            SV *svr;
            SV **closed;
            svr = SvRV(ST(0));
            if (! svr ) {
                croak("PANIC: Could not get reference from blessed object.");
            }
            if (SvTYPE(svr) != SVt_PVHV) {
                croak("PANIC: Underlying storage of blessed reference is not a hash.");
            }
            closed = hv_fetchs( (HV *) svr, "_closed", 0 );
            if (closed != NULL && SvTRUE(*closed)) {
                /* if it's already closed, just return */
                XSRETURN_EMPTY;
            }
        }
        mg = PerlZMQ_Raw_Socket_mg_find(aTHX_ SvRV(ST(0)), &PerlZMQ_Raw_Socket_vtbl);
        if (mg) {
            sock = (PerlZMQ_Raw_Socket *) mg->mg_ptr;
        }
        if (sock == NULL)
            croak("Invalid ZeroMQ::Raw::Socket object (perhaps you've already freed it?)");
    }
;
#line 559 "xs/perl_zeromq.xs"
        switch(option){
            case ZMQ_TYPE:
            case ZMQ_LINGER:
#ifdef ZMQ_RECONNECT_IVL
            case ZMQ_RECONNECT_IVL:
#endif
#ifdef ZMQ_RECONNECT_IVL_MAX
            case ZMQ_RECONNECT_IVL_MAX:
#endif
            case ZMQ_BACKLOG:
            case ZMQ_FD:
                len = sizeof(i);
                status = zmq_getsockopt(sock->socket, option, &i, &len);
                if(status == 0)
                    RETVAL = newSViv(i);
                break;

            case ZMQ_RCVMORE:
            case ZMQ_SWAP:
            case ZMQ_RATE:
            case ZMQ_RECOVERY_IVL:
            case ZMQ_MCAST_LOOP:
                len = sizeof(i64);
                status = zmq_getsockopt(sock->socket, option, &i64, &len);
                if(status == 0)
                    RETVAL = newSViv(i64);
                break;

            case ZMQ_HWM:
            case ZMQ_AFFINITY:
            case ZMQ_SNDBUF:
            case ZMQ_RCVBUF:
                len = sizeof(u64);
                status = zmq_getsockopt(sock->socket, option, &u64, &len);
                if(status == 0)
                    RETVAL = newSVuv(u64);
                break;

            case ZMQ_EVENTS:
                len = sizeof(i32);
                status = zmq_getsockopt(sock->socket, option, &i32, &len);
                if(status == 0)
                    RETVAL = newSViv(i32);
                break;

            case ZMQ_IDENTITY:
                len = sizeof(buf);
                status = zmq_getsockopt(sock->socket, option, &buf, &len);
                if(status == 0)
                    RETVAL = newSVpvn(buf, len);
                break;
        }
        if(status != 0){
        switch(_ERRNO) {
            SET_BANG;
            case EINTR:
                    croak("The operation was interrupted by delivery of a signal");
            case ETERM:
                croak("The 0MQ context accociated with the specified socket was terminated");
            case EFAULT:
                croak("The provided socket was not valid");
                case EINVAL:
                    croak("Invalid argument");
            default:
                croak("Unknown error reading socket option");
        }
    }
#line 1659 "xs/perl_zeromq.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZeroMQ__Raw_zmq_setsockopt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZeroMQ__Raw_zmq_setsockopt)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "sock, option, value");
    {
	PerlZMQ_Raw_Socket *	sock;
	int	option = (int)SvIV(ST(1))
;
	SV *	value = ST(2)
;
#line 635 "xs/perl_zeromq.xs"
        STRLEN len;
        const char *ptr;
        uint64_t u64;
        int64_t  i64;
        int i;
#line 1685 "xs/perl_zeromq.c"
	int	RETVAL;
	dXSTARG;

    {
        MAGIC *mg;
        sock = NULL;
        if (! sv_isobject(ST(0))) {
            croak("Argument is not an object");
        }
        /* if it got here, it's a blessed reference. better be an HV */
        {
            SV *svr;
            SV **closed;
            svr = SvRV(ST(0));
            if (! svr ) {
                croak("PANIC: Could not get reference from blessed object.");
            }
            if (SvTYPE(svr) != SVt_PVHV) {
                croak("PANIC: Underlying storage of blessed reference is not a hash.");
            }
            closed = hv_fetchs( (HV *) svr, "_closed", 0 );
            if (closed != NULL && SvTRUE(*closed)) {
                /* if it's already closed, just return */
                XSRETURN_EMPTY;
            }
        }
        mg = PerlZMQ_Raw_Socket_mg_find(aTHX_ SvRV(ST(0)), &PerlZMQ_Raw_Socket_vtbl);
        if (mg) {
            sock = (PerlZMQ_Raw_Socket *) mg->mg_ptr;
        }
        if (sock == NULL)
            croak("Invalid ZeroMQ::Raw::Socket object (perhaps you've already freed it?)");
    }
;
#line 641 "xs/perl_zeromq.xs"
        switch(option){
            case ZMQ_IDENTITY:
            case ZMQ_SUBSCRIBE:
            case ZMQ_UNSUBSCRIBE:
                ptr = SvPV(value, len);
                RETVAL = zmq_setsockopt(sock->socket, option, ptr, len);
                break;

            case ZMQ_SWAP:
            case ZMQ_RATE:
#ifdef ZMQ_RECONNECT_IVL
            case ZMQ_RECONNECT_IVL:
#endif
#ifdef ZMQ_RECONNECT_IVL_MAX
            case ZMQ_RECONNECT_IVL_MAX:
#endif
            case ZMQ_MCAST_LOOP:
                i64 = SvIV(value);
                RETVAL = zmq_setsockopt(sock->socket, option, &i64, sizeof(int64_t));
                break;

            case ZMQ_HWM:
            case ZMQ_AFFINITY:
            case ZMQ_SNDBUF:
            case ZMQ_RCVBUF:
                u64 = SvUV(value);
                RETVAL = zmq_setsockopt(sock->socket, option, &u64, sizeof(uint64_t));
                break;

            case ZMQ_LINGER:
                i = SvIV(value);
                RETVAL = zmq_setsockopt(sock->socket, option, &i, sizeof(i));
                break;

            default:
                warn("Unknown sockopt type %d, assuming string.  Send patch", option);
                ptr = SvPV(value, len);
                RETVAL = zmq_setsockopt(sock->socket, option, ptr, len);
        }
#line 1760 "xs/perl_zeromq.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZeroMQ__Raw_zmq_poll); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZeroMQ__Raw_zmq_poll)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "list, timeout = 0");
    {
	AV *	list;
	long	timeout;
#line 688 "xs/perl_zeromq.xs"
        I32 list_len;
        zmq_pollitem_t *pollitems;
        CV **callbacks;
        int i;
#line 1781 "xs/perl_zeromq.c"
	int	RETVAL;
	dXSTARG;

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    list = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"ZeroMQ::Raw::zmq_poll",
				"list");
		}
	} STMT_END
;

	if (items < 2)
	    timeout = 0;
	else {
	    timeout = (long)SvIV(ST(1))
;
	}
#line 693 "xs/perl_zeromq.xs"
        list_len = av_len( list ) + 1;
        if (list_len <= 0) {
            XSRETURN(0);
        }

        Newxz( pollitems, list_len, zmq_pollitem_t);
        Newxz( callbacks, list_len, CV *);

        /* list should be a list of hashrefs fd, events, and callbacks */
        for (i = 0; i < list_len; i++) {
            SV **svr = av_fetch( list, i, 0 );
            HV  *elm;
            if (svr == NULL || ! SvOK(*svr) || ! SvROK(*svr) || SvTYPE(SvRV(*svr)) != SVt_PVHV) {
                Safefree( pollitems );
                Safefree( callbacks );
                croak("Invalid value on index %d", i);
            }
            elm = (HV *) SvRV(*svr);

            callbacks[i] = NULL;
            pollitems[i].revents = 0;
            pollitems[i].events  = 0;
            pollitems[i].fd      = 0;
            pollitems[i].socket  = NULL;

            svr = hv_fetch( elm, "socket", 6, NULL );
            if (svr != NULL) {
                MAGIC *mg;
                if (! SvOK(*svr) || !sv_isobject( *svr) || ! sv_isa(*svr, "ZeroMQ::Raw::Socket")) {
                    Safefree( pollitems );
                    Safefree( callbacks );
                    croak("Invalid 'socket' given for index %d", i);
                }
                mg = PerlZMQ_Raw_Socket_mg_find( aTHX_ SvRV(*svr), &PerlZMQ_Raw_Socket_vtbl );
                pollitems[i].socket = ((PerlZMQ_Raw_Socket *) mg->mg_ptr)->socket;
                PerlZMQ_trace( " + pollitem[%d].socket = %p", i, pollitems[i].socket );
            } else {
                svr = hv_fetch( elm, "fd", 2, NULL );
                if (svr == NULL || ! SvOK(*svr) || SvTYPE(*svr) != SVt_IV) {
                    Safefree( pollitems );
                    Safefree( callbacks );
                    croak("Invalid 'fd' given for index %d", i);
                }
                pollitems[i].fd = SvIV( *svr );
            }

            svr = hv_fetch( elm, "events", 6, NULL );
            if (svr == NULL || ! SvOK(*svr) || SvTYPE(*svr) != SVt_IV) {
                Safefree( pollitems );
                Safefree( callbacks );
                croak("Invalid 'events' given for index %d", i);
            }
            pollitems[i].events = SvIV( *svr );

            svr = hv_fetch( elm, "callback", 8, NULL );
            if (svr == NULL || ! SvOK(*svr) || ! SvROK(*svr) || SvTYPE(SvRV(*svr)) != SVt_PVCV) {
                Safefree( pollitems );
                Safefree( callbacks );
                croak("Invalid 'callback' given for index %d", i);
            }
            callbacks[i] = (CV *) SvRV( *svr );
        }

        /* now call zmq_poll */
        RETVAL = zmq_poll( pollitems, list_len, timeout );
        for ( i = 0; i < list_len; i++ ) {
            if (pollitems[i].revents & pollitems[i].events) {
                dSP;
                ENTER;
                SAVETMPS;
                PUSHMARK(SP);
                PUTBACK;

                call_sv( (SV*)callbacks[i], G_SCALAR );
                SPAGAIN;

                PUTBACK;
                FREETMPS;
                LEAVE;
            }
        }
        Safefree(pollitems);
        Safefree(callbacks);
#line 1889 "xs/perl_zeromq.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZeroMQ__Raw_zmq_device); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZeroMQ__Raw_zmq_device)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "device, insocket, outsocket");
    {
	int	device = (int)SvIV(ST(0))
;
	PerlZMQ_Raw_Socket *	insocket;
	PerlZMQ_Raw_Socket *	outsocket;
	int	RETVAL;
	dXSTARG;

    {
        MAGIC *mg;
        insocket = NULL;
        if (! sv_isobject(ST(1))) {
            croak("Argument is not an object");
        }
        /* if it got here, it's a blessed reference. better be an HV */
        {
            SV *svr;
            SV **closed;
            svr = SvRV(ST(1));
            if (! svr ) {
                croak("PANIC: Could not get reference from blessed object.");
            }
            if (SvTYPE(svr) != SVt_PVHV) {
                croak("PANIC: Underlying storage of blessed reference is not a hash.");
            }
            closed = hv_fetchs( (HV *) svr, "_closed", 0 );
            if (closed != NULL && SvTRUE(*closed)) {
                /* if it's already closed, just return */
                XSRETURN_EMPTY;
            }
        }
        mg = PerlZMQ_Raw_Socket_mg_find(aTHX_ SvRV(ST(1)), &PerlZMQ_Raw_Socket_vtbl);
        if (mg) {
            insocket = (PerlZMQ_Raw_Socket *) mg->mg_ptr;
        }
        if (insocket == NULL)
            croak("Invalid ZeroMQ::Raw::Socket object (perhaps you've already freed it?)");
    }
;

    {
        MAGIC *mg;
        outsocket = NULL;
        if (! sv_isobject(ST(2))) {
            croak("Argument is not an object");
        }
        /* if it got here, it's a blessed reference. better be an HV */
        {
            SV *svr;
            SV **closed;
            svr = SvRV(ST(2));
            if (! svr ) {
                croak("PANIC: Could not get reference from blessed object.");
            }
            if (SvTYPE(svr) != SVt_PVHV) {
                croak("PANIC: Underlying storage of blessed reference is not a hash.");
            }
            closed = hv_fetchs( (HV *) svr, "_closed", 0 );
            if (closed != NULL && SvTRUE(*closed)) {
                /* if it's already closed, just return */
                XSRETURN_EMPTY;
            }
        }
        mg = PerlZMQ_Raw_Socket_mg_find(aTHX_ SvRV(ST(2)), &PerlZMQ_Raw_Socket_vtbl);
        if (mg) {
            outsocket = (PerlZMQ_Raw_Socket *) mg->mg_ptr;
        }
        if (outsocket == NULL)
            croak("Invalid ZeroMQ::Raw::Socket object (perhaps you've already freed it?)");
    }
;
#line 785 "xs/perl_zeromq.xs"
        RETVAL = zmq_device( device, insocket->socket, outsocket->socket );
#line 1975 "xs/perl_zeromq.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_ZeroMQ); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_ZeroMQ)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("ZeroMQ::version", XS_ZeroMQ_version);
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_AFFINITY", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_AFFINITY;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_BACKLOG", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_BACKLOG;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_DEALER", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_DEALER;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_DELIMITER", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_DELIMITER;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_DOWNSTREAM", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_DOWNSTREAM;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_EVENTS", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_EVENTS;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_FD", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_FD;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_FORWARDER", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_FORWARDER;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_HAUSNUMERO", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_HAUSNUMERO;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_HWM", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_HWM;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_IDENTITY", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_IDENTITY;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_LINGER", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_LINGER;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_MAX_VSM_SIZE", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_MAX_VSM_SIZE;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_MCAST_LOOP", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_MCAST_LOOP;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_MSG_MASK", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_MSG_MASK;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_MSG_MORE", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_MSG_MORE;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_MSG_SHARED", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_MSG_SHARED;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_NOBLOCK", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_NOBLOCK;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_PAIR", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_PAIR;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_POLLERR", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_POLLERR;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_POLLIN", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_POLLIN;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_POLLOUT", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_POLLOUT;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_PUB", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_PUB;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_PULL", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_PULL;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_PUSH", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_PUSH;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_QUEUE", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_QUEUE;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_RATE", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_RATE;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_RCVBUF", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_RCVBUF;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_RCVMORE", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_RCVMORE;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_RCVTIMEO", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_RCVTIMEO;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_RECONNECT_IVL", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_RECONNECT_IVL;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_RECONNECT_IVL_MAX", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_RECONNECT_IVL_MAX;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_RECOVERY_IVL", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_RECOVERY_IVL;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_RECOVERY_IVL_MSEC", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_RECOVERY_IVL_MSEC;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_REP", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_REP;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_REQ", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_REQ;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_ROUTER", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_ROUTER;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_SNDBUF", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_SNDBUF;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_SNDMORE", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_SNDMORE;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_SNDTIMEO", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_SNDTIMEO;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_STREAMER", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_STREAMER;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_SUB", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_SUB;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_SUBSCRIBE", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_SUBSCRIBE;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_SWAP", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_SWAP;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_TYPE", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_TYPE;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_UNSUBSCRIBE", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_UNSUBSCRIBE;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_UPSTREAM", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_UPSTREAM;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_VERSION", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_VERSION;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_VERSION_MAJOR", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_VERSION_MAJOR;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_VERSION_MINOR", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_VERSION_MINOR;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_VERSION_PATCH", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_VERSION_PATCH;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_VSM", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_VSM;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_XPUB", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_XPUB;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_XREP", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_XREP;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_XREQ", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_XREQ;
        cv = newXS_deffile("ZeroMQ::Constants::ZMQ_XSUB", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = ZMQ_XSUB;
        cv = newXS_deffile("ZeroMQ::Constants::_constant", XS_ZeroMQ__Constants__constant);
        XSANY.any_i32 = 0;
        newXS_deffile("ZeroMQ::Raw::zmq_init", XS_ZeroMQ__Raw_zmq_init);
        newXS_deffile("ZeroMQ::Raw::zmq_term", XS_ZeroMQ__Raw_zmq_term);
        newXS_deffile("ZeroMQ::Raw::zmq_msg_init", XS_ZeroMQ__Raw_zmq_msg_init);
        newXS_deffile("ZeroMQ::Raw::zmq_msg_init_size", XS_ZeroMQ__Raw_zmq_msg_init_size);
        newXS_deffile("ZeroMQ::Raw::zmq_msg_init_data", XS_ZeroMQ__Raw_zmq_msg_init_data);
        newXS_deffile("ZeroMQ::Raw::zmq_msg_data", XS_ZeroMQ__Raw_zmq_msg_data);
        newXS_deffile("ZeroMQ::Raw::zmq_msg_size", XS_ZeroMQ__Raw_zmq_msg_size);
        newXS_deffile("ZeroMQ::Raw::zmq_msg_close", XS_ZeroMQ__Raw_zmq_msg_close);
        newXS_deffile("ZeroMQ::Raw::zmq_msg_move", XS_ZeroMQ__Raw_zmq_msg_move);
        newXS_deffile("ZeroMQ::Raw::zmq_msg_copy", XS_ZeroMQ__Raw_zmq_msg_copy);
        newXS_deffile("ZeroMQ::Raw::zmq_socket", XS_ZeroMQ__Raw_zmq_socket);
        newXS_deffile("ZeroMQ::Raw::zmq_close", XS_ZeroMQ__Raw_zmq_close);
        newXS_deffile("ZeroMQ::Raw::zmq_connect", XS_ZeroMQ__Raw_zmq_connect);
        newXS_deffile("ZeroMQ::Raw::zmq_bind", XS_ZeroMQ__Raw_zmq_bind);
        newXS_deffile("ZeroMQ::Raw::zmq_recv", XS_ZeroMQ__Raw_zmq_recv);
        newXS_deffile("ZeroMQ::Raw::zmq_send", XS_ZeroMQ__Raw_zmq_send);
        newXS_deffile("ZeroMQ::Raw::zmq_getsockopt", XS_ZeroMQ__Raw_zmq_getsockopt);
        newXS_deffile("ZeroMQ::Raw::zmq_setsockopt", XS_ZeroMQ__Raw_zmq_setsockopt);
        newXS_deffile("ZeroMQ::Raw::zmq_poll", XS_ZeroMQ__Raw_zmq_poll);
        newXS_deffile("ZeroMQ::Raw::zmq_device", XS_ZeroMQ__Raw_zmq_device);

    /* Initialisation Section */

#line 200 "xs/perl_zeromq.xs"
    {
        PerlZMQ_trace( "Booting Perl ZeroMQ" );
    }

#line 2152 "xs/perl_zeromq.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

